<template>
  <div
    v-if="isActive"
    class="ui-loading flex w-full flex-col items-center justify-center gap-8 text-violet-600 md:flex-row md:gap-16"
    :class="{
      'fixed left-0 top-0 z-50 h-screen w-full bg-white/95 p-4 backdrop-blur-xl backdrop-grayscale supports-backdrop-blur:bg-white/60':
        overlay,
    }"
    :aria-label="label"
    role="alert"
    aria-busy="true"
    aria-live="assertive"
  >
    <div
      class="size-12 overflow-hidden md:size-16 lg:size-20"
      :class="{
        'size-7 md:size-9 lg:size-12': sm,
        'size-20 md:size-24 lg:size-28': md,
        'size-28 md:size-32 lg:size-36': lg,
        'size-36 md:size-40 lg:size-44': xl,
      }"
    >
      <svg
        class="animate-spin-irregular rounded-full"
        viewBox="0 0 20 20"
        fill="none"
        stroke="currentColor"
        stroke-width="2"
        role="presentation"
        aria-hidden="true"
        focusable="false"
      >
        <circle class="text-violet-300" cx="10" cy="10" r="9" />
        <path d="M 10 1 A 9 9 0 0 1 19 10" />
      </svg>
    </div>
    <slot :steps="{ steps }">
      <div
        v-if="steps.length"
        class="not-prose"
        :class="{
          'xl:1/4 w-4/5 sm:w-2/3 md:w-1/2 lg:w-1/3 2xl:w-1/5': overlay,
        }"
      >
        <ol class="mx-auto space-y-2">
          <ui-loading-step
            v-for="(step, index) of steps"
            :key="typeof step === 'object' ? step.id ?? index : index"
            :label="typeof step === 'string' ? step : step.label"
            :status="typeof step === 'object' ? step.status : undefined"
          />
        </ol>
      </div>
    </slot>
  </div>
</template>

<script lang="ts" setup>
import { onBeforeUnmount, PropType, watch } from 'vue'
import { useScrollLock } from '@vueuse/core'
import { LoadingStep } from '../../propInterfaces'
import { Optional } from '../../types'

defineOptions({
  name: 'UiLoading',
})

const props = defineProps({
  isActive: {
    type: Boolean,
    default: true,
  },
  label: {
    type: String,
    required: true,
  },
  overlay: {
    type: Boolean,
    default: false,
  },
  withScrollLock: {
    type: Boolean,
    default: false,
  },
  steps: {
    /* `id` of LoadingStep is not required but encouraged for compatibility with `useLoading` */
    type: Array as PropType<(Optional<LoadingStep, 'id'> | string)[]>,
    default: () => [],
  },
  sm: {
    type: Boolean,
    default: false,
  },
  md: {
    type: Boolean,
    default: false,
  },
  lg: {
    type: Boolean,
    default: false,
  },
  xl: {
    type: Boolean,
    default: false,
  },
})

const body = document.querySelector('body')
const lock = useScrollLock(body)

/* reactively enable/disable scroll lock */
watch(
  () => [props.isActive, props.withScrollLock],
  ([isActive, withScrollLock]) => {
    lock.value = withScrollLock ? isActive : false
  },
  { immediate: true }, // also trigger the callback on watcher creation to set the initial state
)

/* ensure that the scroll lock is always removed before unmount */
onBeforeUnmount(() => {
  lock.value = false
})
</script>
